/* ########################################################################

		    SMAC FILE USED BY XCORAL EDITOR

   File: 
   Path: 
   Description: 
   Created: Thu Jan 23 10:26:29 MET 1997
   Author: Lionel Fournigault
   Modified: Thu Jan 23 10:26:31 MET 1997
   Last maintained by: Lionel Fournigault

   RCS $Revision$ $State$
   

   ########################################################################

   Note: 

   ########################################################################

   Copyright (c) : Lionel Fournigault

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   ######################################################################## */

int  java_indent_step = 4;

/* ================================================================================
   Java indent region
   ================================================================================ */
void java_indent_region() {

  int init_line = current_line();
  int mark_line, i, start_line, end_line;

  if (mark_position() == -1)
    return;
  
  watch_on();
  goto_mark();
  mark_line = current_line();
  if (mark_line > init_line){
    start_line = init_line;
    end_line = mark_line;
  }
  else {
    start_line = mark_line;
    end_line = init_line;
  }
  goto_line(start_line);

  for (i=start_line; i < end_line; i++ ){
    ada_indent_line();
    goto_next_line();
  }
  ada_indent_line();
  goto_line (init_line);
  goto_beginning_of_line();

  watch_off();
  reset_mark();
}

/* ================================================================================
   Indent buffer
   ================================================================================ */
void java_indent_buffer() {
  
  int line = current_line();
  
  set_mark(0);
  goto_end_of_file();
  
  java_indent_region();
  
  goto_line(line);
  goto_beginning_of_line();
  color_buffer();
  
  reset_mark();
}

{
  if (! function("forward_c_form"))
    load_file("mode.sc");

  key_def("Java", "\t", "c_indent_line");
  key_def("Java", "\r", "c_insert_and_indent");

  key_def("Java", "}", "c_insert_blink_matched_char_and_indent");
  key_def("Java", "]", "c_insert_blink_matched_char_and_indent");
  key_def("Java", ")", "c_insert_blink_matched_char_and_indent");

  key_def("Java", "{", "c_insert_and_indent");
  key_def("Java", ":", "c_insert_and_indent");

  key_def("Java", "^[a", "goto_beginning_of_c_definition");
  key_def("Java", "^[f", "forward_c_form");
  key_def("Java", "^[b", "backward_c_form");

  key_def("Java", "^[d", "delete_next_c_form");
  key_def("Java", "^[\b", "delete_previous_c_form");
  key_def("Java", "^[\177", "delete_previous_c_form");
  
  key_def("Java", "^[i", "java_indent_region");
  
  key_def("Java", "^[u", "upcase_word");
  key_def("Java", "^[l", "downcase_word");
  key_def("Java", "^[c", "capitalize_word");
  
  key_def("Java", "^[?", "select_c_object");
  key_def("Java", "^[^[", "edit_c_object");
}

/* -----------------------------------------------
   Java mode.
   Yes, it's a hack, a sordid hack but I like it.
    Lionel.
   -----------------------------------------------  */
char *java_cl = "-e s/}/};/ -e s/extends/:/ ";
char *java_in = "-e s/implements/,/ -e s/interface/class/ ";
char *java_me = "-e s/protected// -e s/private// -e s/public// ";
char *java_pk = "-e s/^import.*$// -e s/^package.*$// ";
char *java_na = "-e s|\\([A-Za-z][A-Za-z]*\\)\\.|\\1__|g ";
char *java_mi = "-e s/final// -e s/synchronized// ";

char *java_op = concat2(concat3(java_cl,java_in,java_me),
			concat3(java_pk,java_mi,java_na));

char * sed_path = cmd_shell_to_string("which sed");

{
  browser_set_pp("Java", sed_path); /* /usr/bin/sed */
  browser_set_pp_options("Java",java_op);
}
